<h1 align="center">
  <br>
  <img src="doc/logo.png" alt="logo">
  <br>
   Z0SCAN
  <br>
</h1>

<h3 align="center">一款基于Python3的主、被动扫描器项目.</h4>

<h4 align="center" dir="auto">
  中文 | <a href="https://github.com/JiuZero/z0scan/blob/master/README_EN.MD">English</a>
</p>

<p align="center">
  <a href="https://www.gnu.org/licenses/gpl-2.0.en.html">
      <img src="https://img.shields.io/badge/License-GPL2-_red.svg">
  <a href="https://www.python.org/">
      <img src="https://img.shields.io/badge/Language-Python3-yellow.svg">
  <a href="https://github.com/JiuZero/z0scan">
      <img src="https://img.shields.io/pypi/v/z0scan">
  </a>
</p>


## 免责声明

> 本项目及包含工具仅面向合法授权的企业安全建设行为，用户滥用造成的一切后果与作者无关，在使用本工具时，您应确保该行为符合当地的法律法规，并且已经取得了足够的授权。请勿对非授权目标进行扫描。

> 如您在使用本项目及包含工具的过程中存在任何非法行为，您需自行承担相应后果，我们将不承担任何法律及连带责任. 您的使用行为或者您以其他任何明示或者默示方式表示接受本协议的，即视为您已阅读并同意本协议的约束。


## 快速部署

GitHub克隆安装

```
git clone https://github.com/JiuZero/z0scan
cd z0scan
pip install -r requirements.txt
python3 z0scan.py
```

从Pypi中安装

```
pip install z0scan
```


## 使用

```
usage: z0scan [options]

options:
  -h, --help            show this help message and exit
  -v, --version         Show program's version number and exit
  --debug               Show programs's exception
  -l LEVEL, --level LEVEL
                        Different level use different kind of scanner
                        (Default [0, 1, 2, 3])

Proxy:
  Passive Agent Mode Options

  -s SERVER_ADDR, --server-addr SERVER_ADDR
                        Server addr format:(ip:port)

Target:
  Options has to be provided to define the target(s)

  -u URL, --url URL     Target URL (e.g. "http://www.site.com/vuln.php?id=1")
  -f URL_FILE, --file URL_FILE
                        Scan multiple targets given in a textual file

Request:
  Network request options

  -p PROXY, --proxy PROXY
                        Use a proxy to connect to the target URL,Support
                        http,https,socks5,socks4 eg:http@127.0.0.1:8080 or
                        socks5@127.0.0.1:1080
  --timeout TIMEOUT     Seconds to wait before timeout connection (Default
                        10)
  --retry RETRY         Time out retrials times (Default 2)
  --random-agent        Use randomly selected HTTP User-Agent header value

Output:
  Output options

  --html                When selected, the output will be output to the
                        output directory by default, or you can specify
  --json JSON           The json file is generated by default in the output
                        directory, you can change the path

Optimization:
  Optimization options

  -t THREADS, --threads THREADS
                        Max number of concurrent network requests (Default
                        31)
  -iw, --ignore-waf     Ignore the WAF during detection
  -sc, --scan-cookie    Scan cookie during detection
  --disable DISABLE     Disable some plugins (e.g. --disable
                        SQLiBool,SQLiTime)
  --able ABLE           Enable some moudle (e.g. --enable SQLiBool,SQLiTime)
```


## 插件列表

- PerServer

|插件名称|插件简述|
|:---:|:----:|
|IisShortname|IIS短文件名漏洞检测|
|IisNginxParse|IIS与Nginx服务解析漏洞|
|ErrorPage|错误页敏感信息泄露|
|OSSBucketTakeover|OSS储存桶接管|
|NetXSS|.NET通杀XSS|
|NginxCRLF|Nginx服务CRLF注入|
|NginxWebcache|Nginx错误配置-缓存清除|
|SwfFiles|Flash通杀XSS|
|NginxVariableLeakage|Nginx错误配置-变量读取|
|IdeaParse|Idea目录解析|
|BackupDomain|基于域名的备份文件检测|
|PhpinfoCraw|Phpinfo文件发现|

- PerFile

|插件名称|插件简述|
|:---:|:----:|
|SQLiBool|SQL布尔盲注检测|
|SQLiTime|SQL时间盲注检测|
|SQLiError|SQL报错注入检测|
|AspCodeInjection|Asp代码执行|
|PhpCodeInjection|Php代码执行|
|ObjectDeserialization|反序列参数分析|
|JsSensitiveContent|Js敏感信息泄露|
|Jsonp|Js敏感信息泄露|
|PhpRealPath|Php真实目录发现|
|Redirect|重定向|
|XpathInjection|XPATH注入|


- PerFolder

|插件名称|插件简述|
|:---:|:----:|
|BackupFolder|备份文件扫描|
|DirectoryBrowse|目录遍历（路径穿越）|
|RepositoryLeak|仓库源码泄漏|

- 扫描插件有部分未经过调试可能存在Bug
- 更多信息见 [WRITE](https://github.com/JiuZero/z0scan/blob/master/doc/WRITE.MD)

## 被动代理流程图

<h2 align="center">
<img src="doc/process.png" alt="process" >
</h2>

## 其它

更新日记 [CHANGELOG](https://github.com/JiuZero/z0scan/blob/master/doc/CHANGE.MD)

Z0SCAN一文流 [INTERDUCE](https://github.com/JiuZero/z0scan/blob/master/doc/INTERDUCE.MD)

感谢&参考 [THANKS](https://github.com/JiuZero/z0scan/blob/master/doc/THANKS.MD)

GPL-2.0授权许可 [LICENSE](https://github.com/JiuZero/z0scan/blob/master/LICENSE)

## 联系

```
QQ:       3973580951
QQemail:  jiuzer0@qq.com
WeiXin:   JiuZer0
```