<h1 align="center">
  <br>
  <img src="doc/logo.png" alt="logo">
  <br>
   Z0SCAN
  <br>
</h1>

<h3 align="center">The Active And Passive Scanner Project based on Python3.</h4>


<h4 align="center" dir="auto">
  <a href="https://github.com/JiuZero/z0scan/blob/master/README.MD">中文</a> | English
</p>

<p align="center">
  <a href="https://www.gnu.org/licenses/gpl-2.0.en.html">
      <img src="https://img.shields.io/badge/License-GPL2-_red.svg">
  <a href="https://www.python.org/">
      <img src="https://img.shields.io/badge/Language-Python3-yellow.svg">
  <a href="https://github.com/JiuZero/z0scan">
      <img src="https://img.shields.io/pypi/v/z0scan">
  </a>
</p>

## Disclaimer

> This project and the included tools are only intended for legally authorized enterprise security construction activities. Any consequences caused by user abuse are not the responsibility of the author. When using this tool, you should ensure that the behavior complies with local laws and regulations and has obtained sufficient authorization. Do not scan unauthorized targets.

> If you engage in any illegal behavior while using this project and its tools, you shall bear the corresponding consequences on your own, and we will not assume any legal or joint liability Your use or any other express or implied acceptance of this agreement shall be deemed as your reading and agreement to be bound by this agreement.


## Rapid Deployment

Install by cloning from GitHub

```
git clone https://github.com/JiuZero/z0scan
cd z0scan
pip install -r requirements.txt
python3 z0scan.py
```

Install from Pypi

```
pip install z0scan
```

## Usage

```
usage: z0scan [options]

options:
  -h, --help            show this help message and exit
  -v, --version         Show program's version number and exit
  --debug               Show programs's exception
  -l LEVEL, --level LEVEL
                        Different level use different kind of scanner
                        (Default [0, 1, 2, 3])

Proxy:
  Passive Agent Mode Options

  -s SERVER_ADDR, --server-addr SERVER_ADDR
                        Server addr format:(ip:port)

Target:
  Options has to be provided to define the target(s)

  -u URL, --url URL     Target URL (e.g. "http://www.site.com/vuln.php?id=1")
  -f URL_FILE, --file URL_FILE
                        Scan multiple targets given in a textual file

Request:
  Network request options

  -p PROXY, --proxy PROXY
                        Use a proxy to connect to the target URL,Support
                        http,https,socks5,socks4 eg:http@127.0.0.1:8080 or
                        socks5@127.0.0.1:1080
  --timeout TIMEOUT     Seconds to wait before timeout connection (Default
                        10)
  --retry RETRY         Time out retrials times (Default 2)
  --random-agent        Use randomly selected HTTP User-Agent header value

Output:
  Output options

  --html                When selected, the output will be output to the
                        output directory by default, or you can specify
  --json JSON           The json file is generated by default in the output
                        directory, you can change the path

Optimization:
  Optimization options

  -t THREADS, --threads THREADS
                        Max number of concurrent network requests (Default
                        31)
  -iw, --ignore-waf     Ignore the WAF during detection
  -sc, --scan-cookie    Scan cookie during detection
  --disable DISABLE     Disable some plugins (e.g. --disable
                        SQLiBool,SQLiTime)
  --able ABLE           Enable some moudle (e.g. --enable SQLiBool,SQLiTime)
```


## Scanner List

- PerServer

|Plug-in name|Plug-in description|
|:---:|:----:|
|IisShortname|IIS Short File Name Vulnerability Detection|
|IisNginxParse|IIS and Nginx Service Resolution Vulnerability|
|ErrorPage|Sensitive information leakage of error page|
|OSSBucketTakeover|OSS bucket takeover|
|NetXSS|.NET XSS|
|NginxCRLF|Nginx service CRLF injection |
|NginxWebcache|Nginx Misconfiguration - Cache Clear|
|SwfFiles|Flash kills XSS|
|NginxVariableLeakage|Nginx Misconfiguration - Variable Read |
|IdeaParse|Idea directory parsing|
|BackupDomain|domain-based backup file detection|
|PhpinfoCraw|Phpinfo file discovery|

- PerFile

|Plug-in name|Plug-in description|
|:---:|:----:|
|SQLiBool|SQL Boolean Blind Note Detection|
|SQLiTime|SQL Time Blind Detection|
|SQLiError|SQL Error Injection Detection|
|AspCodeInjection|ASP code execution|
|PhpCodeInjection|PHP code execution |
|ObjectDeserialization|deserialization|
|JsSensitiveContent|JS Sensitive Information Leakage|
|Jsonp|JS Sensitive Information Leakage|
|PhpRealPath|PHP Real Directory Discovery|
|Redirect|Redirect|
|XpathInjection|XPATH Injection|

- PerFolder

|Plug-in name|Plug-in description|
|:---:|:----:|
|BackupFolder|Backup File Scan|
|DirectoryBrowse|directory traversal (path traversal)|
|RepositoryLeak|repository source code leak|

- Note: The loading premise ignores fingerprint elements (the ability to ignore fingerprint elements is still under development)


## Passive Process

<h1 align="center">
<img src="doc/process.png" alt="process" >
</h1>


## Miscellaneous

UPDATE JOURNAL [CHANGELOG](https://github.com/JiuZero/z0scan/blob/master/doc/CHANGE.MD)

Z0SCAN [INTERDUCE](https://github.com/JiuZero/z0scan/blob/master/doc/INTERDUCE.MD)

THANKS&REFERENCE [THANKS](https://github.com/JiuZero/z0scan/blob/master/doc/THANKS.MD)

GPL-2.0 [LICENSE](https://github.com/JiuZero/z0scan/blob/master/LICENSE)

## Contact

```
QQ: 3973580951
QQemail: jiuzer0@qq.com
WeiXin: JiuZer0
```